-----------------------------------
-- Scannex Electronics Ltd
-- www.scannex.co.uk
-- 2008-11-14 SM
-----------------------------------
-- The following script was written
-- to alert on 911 calls
-- from Siemens PBX.
-----------------------------------

alert.register_oneshot("911Call")                                       --Assign an alert
alert.register_trap("911Call", 10911)                                   --Assign a specific trap number as well

-----------------------------------------------------
-- 911 call checks specific code here...
-----------------------------------------------------
function call911_check(txt, chnl, tag)
 txt=string.gsub(txt,"\x7f","")                                         --Filter out 0x7f characters
 mem.write(chnl, txt)                                                   --Write the record to the channel storage first
 local call_type = string.match(txt, "%d+", 78) or ""                   --Pull out whether it's a call to an outside line
 local call_number = call_type..(string.match(txt, "%d+", 48) or "")    --Pull out what number was dialled
 local caller = string.match(txt, "[%d%u]%d%d%d+", 34) or ""            --Pull out the caller extension

 if (call_number=="9911")                                               --If an external line was dialled as well as 911
 then
  alert.alarm("911Call", "911 Call from "..caller)                      --Send out the email alert to warn of 911 call
 end
 if (call_number=="911")                                                --If no external line was dialled with 911
 then
  alert.alarm("911Call", "911 Attempt from "..caller)                   --Send out the email alert to warn of an attempted 911 call
 end
end

x.chnl[1].src.onrecord = call911_check                                  --Bind the event
